
bool reset;

StructuredBuffer<float3> resetPos;


struct particle
{
	float3 pos;
	float3 vel;
};
RWStructuredBuffer<particle> Output : BACKBUFFER;


int total;
float atraction=1;
float3 centre;
//==============================================================================
//COMPUTE SHADER ===============================================================
//==============================================================================

[numthreads(64, 1, 1)]
void CSConstantForce( uint3 DTid : SV_DispatchThreadID )
{
	if (reset)
	{
		Output[DTid.x].pos = resetPos[DTid.x];
		Output[DTid.x].vel = 0;		
	}
	
	else
	{

		float3 c=0;
		for( uint i = 0; i < total; i++ )
			{
			if (DTid.x != i)
				{
				
				 Output[DTid.x].vel += Output[i].vel;
				
				}
			
			c=c/(total-1); //get average positon of all boids
			
			}
		c+=centre;
		Output[DTid.x].vel = Output[DTid.x].pos;
		Output[DTid.x].pos += (c-Output[DTid.x].vel)/(total*atraction);
		Output[DTid.x].vel = Output[DTid.x].vel-Output[DTid.x].pos;
	}
	
}



//==============================================================================
//TECHNIQUES ===================================================================
//==============================================================================

technique11 simulation
{
	pass P0
	{
		SetComputeShader( CompileShader( cs_5_0, CSConstantForce() ) );
	}
}
